# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
# -*- coding: utf-8 -*-
import dataiku
from openai import OpenAI

# Provide the OpenAI API key
auth_info = dataiku.api_client().get_auth_info(with_secrets=True)
for secret in auth_info["secrets"]:
    if secret["key"] == "openai_key":
        client = OpenAI(api_key=secret["value"])
        break

df = dataiku.Dataset("movie_quotes").get_dataframe()

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: CODE
categories = None

for i in df.index:
    # Call the Moderation endpoint of the OpenAI API
    response = client.moderations.create(input=df.loc[i].text)
    if categories is None:
        categories = list(response.results[0].categories.dict().keys())
    for category in categories:
        df.at[i, category] = response.results[0].category_scores.dict()[category]

# -------------------------------------------------------------------------------- NOTEBOOK-CELL: RAW
dataiku.Dataset("moderation_openai").write_with_schema(df)